Index: LMDZ5/branches/testing/libf/phylmd/cosp/MISR_simulator.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cosp/MISR_simulator.F	(revision 2298)
+++ LMDZ5/branches/testing/libf/phylmd/cosp/MISR_simulator.F	(revision 2298)
@@ -0,0 +1,460 @@
+! 
+! Copyright (c) 2009,  Roger Marchand, version 1.2
+! All rights reserved.
+! 
+! Redistribution and use in source and binary forms, with or without modification, are permitted 
+! provided that the following conditions are met:
+! 
+!     * Redistributions of source code must retain the above copyright notice, this list of 
+!       conditions and the following disclaimer.
+!     * Redistributions in binary form must reproduce the above copyright notice, this list 
+!       of conditions and the following disclaimer in the documentation and/or other materials 
+!       provided with the distribution.
+!     * Neither the name of the University of Washington nor the names of its contributors may be used 
+!       to endorse or promote products derived from this software without specific prior written permission.
+! 
+! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
+! BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
+! SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
+! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
+! INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
+! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+!
+
+      SUBROUTINE MISR_simulator(
+     &     npoints,
+     &     nlev,
+     &     ncol,
+     &     sunlit,
+     & 	   zfull,
+     &	   at,
+     &     dtau_s,
+     &	   dtau_c,
+     &	   frac_out,
+     & 	   fq_MISR_TAU_v_CTH,
+     &	   dist_model_layertops,
+     & 	   MISR_mean_ztop,
+     &     MISR_cldarea
+     & )
+	
+
+      implicit none
+      integer n_MISR_CTH
+      parameter(n_MISR_CTH=16)
+         
+!     -----
+!     Input 
+!     -----
+
+      INTEGER npoints                   !  if ncol ==1, the number of model points in the horizontal grid  
+      				        !   else 	the number of GCM grid points
+      				        
+      INTEGER nlev                      !  number of model vertical levels
+      
+      INTEGER ncol                      !  number of model sub columns 
+      					!  (must already be generated in via scops and passed to this
+      					!   routine via the variable frac_out )
+  
+      INTEGER sunlit(npoints)           !  1 for day points, 0 for night time
+
+      REAL zfull(npoints,nlev)	      	!  height (in meters) of full model levels (i.e. midpoints)
+                                        !  zfull(npoints,1)    is    top level of model
+                                        !  zfull(npoints,nlev) is bottom level of model (closest point to surface)  
+
+      REAL at(npoints,nlev)             !  temperature in each model level (K)
+ 
+      REAL dtau_s(npoints,nlev)         !  visible wavelength cloud optical depth ... for "stratiform" condensate
+                                        !  NOTE:  this the cloud optical depth of only the
+					!	  the model cell (i,j)
+					
+      REAL dtau_c(npoints,nlev)         !  visible wavelength cloud optical depth ... for "convective" condensate
+                                        !  NOTE:  this the cloud optical depth of only the
+					!	  the model cell (i,j)
+                                     
+      REAL frac_out(npoints,ncol,nlev)  !  NOTE: only need if columns>1 ... subgrid scheme in use.
+                                 
+!     ------
+!     Outputs
+!     ------
+       		
+      REAL fq_MISR_TAU_v_CTH(npoints,7,n_MISR_CTH)      
+      REAL dist_model_layertops(npoints,n_MISR_CTH)
+      REAL MISR_cldarea(npoints)		       ! fractional area coverged by clouds 
+      REAL MISR_mean_ztop(npoints)		       ! mean cloud top hieght(m) MISR would observe
+      						       ! NOTE: == 0 if area ==0
+      						
+
+!     ------
+!     Working variables 
+!     ------
+
+      REAL tau(npoints,ncol) 		! total column optical depth ... 
+
+      INTEGER j,ilev,ilev2,ibox
+      INTEGER itau
+         
+      LOGICAL box_cloudy(npoints,ncol)
+      
+      real isccp_taumin
+      real boxarea
+      real tauchk
+      REAL box_MISR_ztop(npoints,ncol)	! cloud top hieght(m) MISR would observe
+      
+      integer thres_crossed_MISR 
+      integer loop,iMISR_ztop
+      
+      real dtau, cloud_dtau, MISR_penetration_height,ztest     
+      
+      real MISR_CTH_boundaries(n_MISR_CTH+1)
+      
+      DATA MISR_CTH_boundaries / -99, 0, 0.5, 1, 1.5, 2, 2.5, 3,
+     c				      4, 5, 7, 9, 11, 13, 15, 17, 99 /
+      
+      DATA isccp_taumin / 0.3 /
+    
+      tauchk = -1.*log(0.9999999)
+    	
+      !
+      !	For each GCM cell or horizontal model grid point ...
+      !	
+      do j=1,npoints	
+
+         !
+         !	estimate distribution of Model layer tops
+         !	
+         dist_model_layertops(j,:)=0
+
+	 do ilev=1,nlev	
+			
+		! define location of "layer top"
+		if(ilev.eq.1 .or. ilev.eq.nlev) then
+			ztest=zfull(j,ilev)
+		else
+			ztest=0.5*(zfull(j,ilev)+zfull(j,ilev-1)) 
+		endif	
+
+		! find MISR layer that contains this level
+		! note, the first MISR level is "no height" level
+		iMISR_ztop=2
+		do loop=2,n_MISR_CTH
+		
+			if ( ztest .gt.
+     &				  1000*MISR_CTH_boundaries(loop+1) ) then
+	    
+  				iMISR_ztop=loop+1
+   			endif
+		enddo
+
+		dist_model_layertops(j,iMISR_ztop)=
+     &			dist_model_layertops(j,iMISR_ztop)+1
+	 enddo
+	
+	
+         !
+         ! compute total cloud optical depth for each column
+         !       
+         do ibox=1,ncol     
+	   
+	    ! Initialize tau to zero in each subcolum
+      	    tau(j,ibox)=0. 
+	    box_cloudy(j,ibox)=.false.
+	    box_MISR_ztop(j,ibox)=0  
+	    
+	    ! initialize threshold detection for each sub column 
+	    thres_crossed_MISR=0;
+	   
+	    do ilev=1,nlev
+     
+     		 dtau=0
+     		 
+     		 if (frac_out(j,ibox,ilev).eq.1) then
+                        dtau = dtau_s(j,ilev)
+                 endif
+                 
+                 if (frac_out(j,ibox,ilev).eq.2) then
+                        dtau = dtau_c(j,ilev)
+                 end if	
+                 
+        	 tau(j,ibox)=tau(j,ibox)+ dtau
+        	  
+        	    	 
+		! NOW for MISR ..
+		! if there a cloud ... start the counter ... store this height
+		if(thres_crossed_MISR .eq. 0 .and. dtau .gt. 0.) then
+		
+			! first encountered a "cloud"
+			thres_crossed_MISR=1  
+			cloud_dtau=0			
+		endif	
+				
+		if( thres_crossed_MISR .lt. 99 .and.
+     &		    	thres_crossed_MISR .gt. 0 ) then
+     
+     			if( dtau .eq. 0.) then
+		
+     				! we have come to the end of the current cloud
+				! layer without yet selecting a CTH boundary.
+				! ... restart cloud tau counter 
+				cloud_dtau=0
+			else
+				! add current optical depth to count for 
+				! the current cloud layer
+				cloud_dtau=cloud_dtau+dtau
+			endif
+				
+			! if the cloud is continuous but optically thin (< 1)
+			! from above the current layer cloud top to the current level
+			! then MISR will like see a top below the top of the current 
+			! layer
+			if( dtau.gt.0 .and. (cloud_dtau-dtau) .lt. 1) then
+			
+				if(dtau .lt. 1 .or. ilev.eq.1 .or. ilev.eq.nlev) then
+
+					! MISR will likely penetrate to some point
+					! within this layer ... the middle
+					MISR_penetration_height=zfull(j,ilev)
+
+				else
+				   	! take the OD = 1.0 level into this layer
+				   	MISR_penetration_height=
+     &					   0.5*(zfull(j,ilev)+zfull(j,ilev-1)) - 
+     &					   0.5*(zfull(j,ilev-1)-zfull(j,ilev+1))
+     &					/dtau 
+				endif	
+
+				box_MISR_ztop(j,ibox)=MISR_penetration_height
+				
+			endif
+		
+			! check for a distinctive water layer
+			if(dtau .gt. 1 .and. at(j,ilev).gt.273 ) then
+     
+     				! must be a water cloud ... 
+				! take this as CTH level
+				thres_crossed_MISR=99
+			endif
+		
+			! if the total column optical depth is "large" than
+			! MISR can't seen anything else ... set current point as CTH level
+			if(tau(j,ibox) .gt. 5) then	
+
+				thres_crossed_MISR=99			
+			endif
+
+		endif ! MISR CTH booundary not set
+		
+      	    enddo  !ilev - loop over vertical levesl
+	
+	    ! written by roj 5/2006
+	    ! check to see if there was a cloud for which we didn't 
+	    ! set a MISR cloud top boundary
+	    if( thres_crossed_MISR .eq. 1) then
+	
+		! if the cloud has a total optical depth of greater
+		! than ~ 0.5 MISR will still likely pick up this cloud
+		! with a height near the true cloud top
+		! otherwise there should be no CTH
+		if( tau(j,ibox) .gt. 0.5) then
+
+			! keep MISR detected CTH
+			
+		elseif(tau(j,ibox) .gt. 0.2) then
+
+			! MISR may detect but wont likley have a good height
+			box_MISR_ztop(j,ibox)=-1
+			
+		else
+			! MISR not likely to even detect.
+			! so set as not cloudy
+			box_MISR_ztop(j,ibox)=0
+
+		endif
+						
+	    endif
+	
+	 enddo  ! loop of subcolumns
+       enddo    ! loop of gridpoints
+       
+
+        !     
+        !	Modify MISR CTH for satellite spatial / pattern matcher effects
+	!
+	!	Code in this region added by roj 5/2006 to account
+	!	for spatial effect of the MISR pattern matcher.
+	!	Basically, if a column is found between two neighbors
+	! 	at the same CTH, and that column has no hieght or
+	!	a lower CTH, THEN misr will tend to but place the
+	!	odd column at the same height as it neighbors.
+	!
+	!	This setup assumes the columns represent a about a 1 to 4 km scale
+	!	it will need to be modified significantly, otherwise
+	if(ncol.eq.1) then
+	
+	   ! adjust based on neightboring points ... i.e. only 2D grid was input
+           do j=2,npoints-1
+			
+			if(box_MISR_ztop(j-1,1).gt.0 .and. 
+     &			   box_MISR_ztop(j+1,1).gt.0 	   ) then
+
+				if( abs( box_MISR_ztop(j-1,1) -  
+     &				  	 box_MISR_ztop(j+1,1) ) .lt. 500 
+     & 				.and.
+     &					 box_MISR_ztop(j,1) .lt. 
+     &					 box_MISR_ztop(j+1,1)     ) then
+			
+					box_MISR_ztop(j,1) =
+     &						box_MISR_ztop(j+1,1)    
+				endif
+
+			endif
+         enddo
+      else
+         
+         ! adjust based on neighboring subcolumns ....
+         do ibox=2,ncol-1
+			
+			if(box_MISR_ztop(1,ibox-1).gt.0 .and. 
+     &			   box_MISR_ztop(1,ibox+1).gt.0 	   ) then
+
+				if( abs( box_MISR_ztop(1,ibox-1) -  
+     &				  	 box_MISR_ztop(1,ibox+1) ) .lt. 500 
+     & 				.and.
+     &					 box_MISR_ztop(1,ibox) .lt. 
+     &					 box_MISR_ztop(1,ibox+1)     ) then
+			
+					box_MISR_ztop(1,ibox) =
+     &						box_MISR_ztop(1,ibox+1)    
+				endif
+
+			endif
+         enddo
+      
+      endif
+
+        !     
+	!     DETERMINE CLOUD TYPE FREQUENCIES
+	!
+	!     Now that ztop and tau have been determined, 
+	!     determine amount of each cloud type
+      boxarea=1./real(ncol)  
+      do j=1,npoints 
+
+         ! reset frequencies -- modified loop structure, roj 5/2006 
+         do ilev=1,7  ! "tau loop"	
+            do  ilev2=1,n_MISR_CTH	    		        
+      		fq_MISR_TAU_v_CTH(j,ilev,ilev2)=0.     
+            enddo
+      	 enddo
+      	   
+	 MISR_cldarea(j)=0.
+      	 MISR_mean_ztop(j)=0.
+
+         do ibox=1,ncol
+
+            if (tau(j,ibox) .gt. (tauchk)) then
+               box_cloudy(j,ibox)=.true.
+            endif
+  
+  	    itau = 0
+  	    
+            if (box_cloudy(j,ibox)) then
+	
+	      !determine optical depth category
+              if (tau(j,ibox) .lt. isccp_taumin) then
+                  itau=1
+              else if (tau(j,ibox) .ge. isccp_taumin                                    
+     &          .and. tau(j,ibox) .lt. 1.3) then
+                  itau=2
+              else if (tau(j,ibox) .ge. 1.3 
+     &          .and. tau(j,ibox) .lt. 3.6) then
+                  itau=3
+              else if (tau(j,ibox) .ge. 3.6 
+     &          .and. tau(j,ibox) .lt. 9.4) then
+                  itau=4
+              else if (tau(j,ibox) .ge. 9.4 
+     &          .and. tau(j,ibox) .lt. 23.) then
+                  itau=5
+              else if (tau(j,ibox) .ge. 23. 
+     &          .and. tau(j,ibox) .lt. 60.) then
+                  itau=6
+              else if (tau(j,ibox) .ge. 60.) then
+                  itau=7
+              endif
+              
+	   endif  
+
+	   ! update MISR histograms and summary metrics - roj 5/2005
+	   if (sunlit(j).eq.1) then 
+              	     
+              !if cloudy added by roj 5/2005
+	      if( box_MISR_ztop(j,ibox).eq.0) then
+	      
+			! no cloud detected
+			iMISR_ztop=0
+
+	      elseif( box_MISR_ztop(j,ibox).eq.-1) then
+
+			! cloud can be detected but too thin to get CTH
+			iMISR_ztop=1    
+
+     			fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop)=
+     &          		fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop) + boxarea
+
+	      else
+	      	
+			!
+			! determine index for MISR bin set
+			!
+
+			iMISR_ztop=2
+			
+			do loop=2,n_MISR_CTH
+		
+				if ( box_MISR_ztop(j,ibox) .gt.
+     &				  1000*MISR_CTH_boundaries(loop+1) ) then
+	    
+				  iMISR_ztop=loop+1
+
+   				endif
+			enddo
+	      
+			if(box_cloudy(j,ibox)) then
+			
+				! there is an isccp clouds so itau(j) is defined
+     				fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop)=
+     &          			fq_MISR_TAU_v_CTH(j,itau,iMISR_ztop) + boxarea
+     
+			else
+				! MISR CTH resolution is trying to fill in a
+				! broken cloud scene where there is no condensate.
+				! The MISR CTH-1D-OD product will only put in a cloud
+				! if the MISR cloud mask indicates cloud.
+				! therefore we will not include this column in the histogram
+				! in reality aerosoal and 3D effects or bright surfaces
+				! could fool the MISR cloud mask
+
+				! the alternative is to count as very thin cloud ??
+!				fq_MISR_TAU_v_CTH(1,iMISR_ztop)=
+!     &          			fq_MISR_TAU_v_CTH(1,iMISR_ztop) + boxarea
+			endif
+
+
+			MISR_mean_ztop(j)=MISR_mean_ztop(j)+
+     &					     box_MISR_ztop(j,ibox)*boxarea   		
+
+			MISR_cldarea(j)=MISR_cldarea(j) + boxarea 
+ 
+	      endif
+		
+	   endif ! is sunlight ?
+	   
+	enddo ! ibox - loop over subcolumns          
+      
+	if( MISR_cldarea(j) .gt. 0.) then
+	  	MISR_mean_ztop(j)= MISR_mean_ztop(j) / MISR_cldarea(j)   ! roj 5/2006
+	endif
+
+      enddo  ! loop over grid points
+
+      return
+      end 
Index: LMDZ5/branches/testing/libf/phylmd/cosp/array_lib.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cosp/array_lib.F90	(revision 2298)
+++ LMDZ5/branches/testing/libf/phylmd/cosp/array_lib.F90	(revision 2298)
@@ -0,0 +1,165 @@
+! ARRAY_LIB: Array procedures for F90
+! Compiled/Modified:
+!   07/01/06  John Haynes (haynes@atmos.colostate.edu)
+!
+! infind (function)
+! lin_interpolate (function)
+  
+  module array_lib
+  implicit none
+
+  contains
+
+! ----------------------------------------------------------------------------
+! function INFIND
+! ----------------------------------------------------------------------------
+  function infind(list,val,sort,dist)
+  use m_mrgrnk
+  implicit none
+!
+! Purpose:
+!   Finds the index of an array that is closest to a value, plus the
+!   difference between the value found and the value specified
+!
+! Inputs:
+!   [list]   an array of sequential values
+!   [val]    a value to locate
+! Optional input:
+!   [sort]   set to 1 if [list] is in unknown/non-sequential order
+!
+! Returns:
+!   index of [list] that is closest to [val]
+!
+! Optional output:
+!   [dist]   set to variable containing [list([result])] - [val]
+!
+! Requires:
+!   mrgrnk library
+!
+! Created:
+!   10/16/03  John Haynes (haynes@atmos.colostate.edu)
+! Modified:
+!   01/31/06  IDL to Fortran 90
+ 
+! ----- INPUTS -----
+  real*8, dimension(:), intent(in) :: list
+  real*8, intent(in) :: val  
+  integer, intent(in), optional :: sort
+  
+! ----- OUTPUTS -----
+  integer*4 :: infind
+  real*8, intent(out), optional :: dist
+
+! ----- INTERNAL -----
+  real*8, dimension(size(list)) :: lists
+  integer*4 :: nlist, result, tmp(1), sort_list
+  integer*4, dimension(size(list)) :: mask, idx
+
+  if (present(sort)) then
+    sort_list = sort
+  else
+    sort_list = 0
+  endif  
+
+  nlist = size(list)
+  if (sort_list == 1) then
+    call mrgrnk(list,idx)
+    lists = list(idx)
+  else
+    lists = list
+  endif
+
+  if (val >= lists(nlist)) then
+    result = nlist
+  else if (val <= lists(1)) then
+    result = 1
+  else
+    mask(:) = 0
+    where (lists < val) mask = 1
+      tmp = minloc(mask,1)
+      if (abs(lists(tmp(1)-1)-val) < abs(lists(tmp(1))-val)) then
+        result = tmp(1) - 1
+      else
+        result = tmp(1)
+      endif
+  endif
+  if (present(dist)) dist = lists(result)-val
+  if (sort_list == 1) then
+    infind = idx(result)
+  else
+    infind = result
+  endif
+
+  end function infind
+
+! ----------------------------------------------------------------------------
+! function LIN_INTERPOLATE
+! ----------------------------------------------------------------------------  
+  subroutine lin_interpolate(yarr,xarr,yyarr,xxarr,tol)
+  use m_mrgrnk
+  implicit none
+!
+! Purpose:
+!   linearly interpolate a set of y2 values given a set of y1,x1,x2
+!
+! Inputs:
+!   [yarr]    an array of y1 values
+!   [xarr]    an array of x1 values
+!   [xxarr]   an array of x2 values
+!   [tol]     maximum distance for a match
+!
+! Output:
+!   [yyarr]   interpolated array of y2 values
+!
+! Requires:
+!   mrgrnk library
+!
+! Created:
+!   06/07/06  John Haynes (haynes@atmos.colostate.edu)
+
+! ----- INPUTS -----
+  real*8, dimension(:), intent(in) :: yarr, xarr, xxarr
+  real*8, intent(in) :: tol
+
+! ----- OUTPUTS -----
+  real*8, dimension(size(xxarr)), intent(out) :: yyarr
+
+! ----- INTERNAL -----
+  real*8, dimension(size(xarr)) :: ysort, xsort
+  integer*4, dimension(size(xarr)) :: ist
+  integer*4 :: nx, nxx, i, iloc
+  real*8 :: d, m
+
+  nx = size(xarr)
+  nxx = size(xxarr)
+
+! // xsort, ysort are sorted versions of xarr, yarr  
+  call mrgrnk(xarr,ist)
+  ysort = yarr(ist)
+  xsort = xarr(ist)
+  
+  do i=1,nxx
+    iloc = infind(xsort,xxarr(i),dist=d)
+    if (d > tol) then
+      print *, 'interpolation error'
+      stop
+    endif
+    if (iloc == nx) then
+!     :: set to the last value
+      yyarr(i) = ysort(nx)
+    else
+!     :: is there another closeby value?
+      if (abs(xxarr(i)-xsort(iloc+1)) < 2*tol) then
+!       :: yes, do a linear interpolation      
+        m = (ysort(iloc+1)-ysort(iloc))/(xsort(iloc+1)-xsort(iloc))
+        yyarr(i) = ysort(iloc) + m*(xxarr(i)-xsort(iloc))
+      else
+!       :: no, set to the only nearby value
+        yyarr(i) = ysort(iloc)
+      endif
+    endif
+  enddo
+  
+  end subroutine lin_interpolate
+
+  end module array_lib
Index: LMDZ5/branches/testing/libf/phylmd/cosp/atmos_lib.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cosp/atmos_lib.F90	(revision 2298)
+++ LMDZ5/branches/testing/libf/phylmd/cosp/atmos_lib.F90	(revision 2298)
@@ -0,0 +1,135 @@
+! ATMOS_LIB: Atmospheric science procedures for F90
+! Compiled/Modified:
+!   07/01/06  John Haynes (haynes@atmos.colostate.edu)
+!
+! mcclatchey (subroutine)
+  
+  module atmos_lib
+  implicit none
+  
+  contains
+  
+! ----------------------------------------------------------------------------
+! subroutine MCCLATCHEY
+! ----------------------------------------------------------------------------
+  subroutine mcclatchey(stype,hgt,prs,tk,rh)
+  implicit none
+!
+! Purpose:
+!   returns a standard atmospheric profile
+!
+! Input:
+!   [stype]   type of profile to return
+!             1 = mid-latitude summer
+!             2 = mid-latitude winter
+!             3 = tropical
+!
+! Outputs:
+!   [hgt]     height (m)
+!   [prs]     pressure (hPa)
+!   [tk]      temperature (K)
+!   [rh]      relative humidity (%)
+!
+! Created:
+!   06/01/2006  John Haynes (haynes@atmos.colostate.edu)
+
+! ----- INPUTS -----
+  integer, intent(in) :: &
+  stype
+
+  integer, parameter :: ndat = 33
+
+! ----- OUTPUTS -----
+  real*8, intent(out), dimension(ndat) :: &
+  hgt, &                        ! height (m)
+  prs, &                        ! pressure (hPa)
+  tk, &                         ! temperature (K)
+  rh                            ! relative humidity (%)
+  
+  hgt = (/0.00000,1000.00,2000.00,3000.00,4000.00,5000.00, &
+          6000.00,7000.00,8000.00,9000.00,10000.0,11000.0, &
+          12000.0,13000.0,14000.0,15000.0,16000.0,17000.0, &
+          18000.0,19000.0,20000.0,21000.0,22000.0,23000.0, &
+          24000.0,25000.0,30000.0,35000.0,40000.0,45000.0, &
+          50000.0,70000.0,100000./)
+
+  select case(stype)
+
+  case(1)
+!   // mid-latitide summer  
+    prs = (/1013.00, 902.000, 802.000, 710.000, 628.000, 554.000, &
+            487.000, 426.000, 372.000, 324.000, 281.000, 243.000, &
+            209.000, 179.000, 153.000, 130.000, 111.000, 95.0000, &
+            81.2000, 69.5000, 59.5000, 51.0000, 43.7000, 37.6000, &
+            32.2000, 27.7000, 13.2000, 6.52000, 3.33000, 1.76000, &
+            0.951000,0.0671000,0.000300000/)
+	   
+    tk =  (/294.000, 290.000, 285.000, 279.000, 273.000, 267.000, &
+            261.000, 255.000, 248.000, 242.000, 235.000, 229.000, &
+            222.000, 216.000, 216.000, 216.000, 216.000, 216.000, &
+            216.000, 217.000, 218.000, 219.000, 220.000, 222.000, &
+            223.000, 224.000, 234.000, 245.000, 258.000, 270.000, &
+            276.000, 218.000, 210.000/)
+
+    rh =  (/74.8384, 63.4602, 55.0485, 45.4953, 39.3805, 31.7965, &
+            30.3958, 29.5966, 30.1626, 29.3624, 30.3334, 19.0768, &
+            11.0450, 6.61278, 3.67379, 2.79209, 2.35123, 2.05732, &
+            1.83690, 1.59930, 1.30655, 1.31890, 1.17620,0.994076, &
+            0.988566,0.989143,0.188288,0.0205613,0.00271164,0.000488798, &
+            0.000107066,0.000406489,7.68645e-06/)
+
+  case(2)
+!   // mid-latitude winter
+    prs = (/1018.00, 897.300, 789.700, 693.800, 608.100, 531.300, &
+            462.700, 401.600, 347.300, 299.200, 256.800, 219.900, &
+            188.200, 161.000, 137.800, 117.800, 100.700, 86.1000, &
+            73.5000, 62.8000, 53.7000, 45.8000, 39.1000, 33.4000, &
+            28.6000, 24.3000, 11.1000, 5.18000, 2.53000, 1.29000, &
+            0.682000,0.0467000,0.000300000/)
+
+    tk =  (/272.200, 268.700, 265.200, 261.700, 255.700, 249.700, &
+            243.700, 237.700, 231.700, 225.700, 219.700, 219.200, &
+            218.700, 218.200, 217.700, 217.200, 216.700, 216.200, &
+            215.700, 215.200, 215.200, 215.200, 215.200, 215.200, &
+            215.200, 215.200, 217.400, 227.800, 243.200, 258.500, &
+            265.700, 230.700, 210.200/)
+
+    rh =  (/76.6175, 70.1686, 65.2478, 56.6267, 49.8755, 47.1765, &
+            44.0477, 31.0565, 23.0244, 19.6510, 17.8987, 17.4376, &
+            16.0621, 5.10608, 3.00679, 2.42293, 2.16406, 2.00901, &
+            1.90374, 1.98072, 1.81902, 2.06155, 2.06154, 2.18280, &
+            2.42531,2.70824,1.12105,0.108119,0.00944200,0.00115201, &
+            0.000221094,0.000101946,7.49350e-06/)
+
+  case(3)
+!   // tropical
+    prs = (/1013.00, 904.000, 805.000, 715.000, 633.000, 559.000, &
+            492.000, 432.000, 378.000, 329.000, 286.000, 247.000, &
+            213.000, 182.000, 156.000, 132.000, 111.000, 93.7000, &
+            78.9000, 66.6000, 56.5000, 48.0000, 40.9000, 35.0000, &
+            30.0000, 25.7000, 12.2000, 6.00000, 3.05000, 1.59000, &
+            0.854000,0.0579000,0.000300000/)
+
+    tk =  (/300.000, 294.000, 288.000, 284.000, 277.000, 270.000, &
+            264.000, 257.000, 250.000, 244.000, 237.000, 230.000, &
+            224.000, 217.000, 210.000, 204.000, 197.000, 195.000, &
+            199.000, 203.000, 207.000, 211.000, 215.000, 217.000, &
+            219.000, 221.000, 232.000, 243.000, 254.000, 265.000, &
+            270.000, 219.000, 210.000/)
+
+    rh =  (/71.4334, 69.4097, 71.4488, 46.7724, 34.7129, 38.3820, &
+            33.7214, 32.0122, 30.2607, 24.5059, 19.5321, 13.2966, &
+            8.85795, 5.87496, 7.68644, 12.8879, 29.4976, 34.9351, &
+            17.1606, 9.53422, 5.10154, 3.45407, 2.11168, 1.76247, &
+            1.55162,1.37966,0.229799,0.0245943,0.00373686,0.000702138, &
+            0.000162076,0.000362055,7.68645e-06/)
+	    
+  case default
+    print *, 'Must enter a profile type'
+    stop
+    
+  end select
+  
+  end subroutine mcclatchey
+  
+  end module atmos_lib
Index: LMDZ5/branches/testing/libf/phylmd/cosp/congvec.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cosp/congvec.h	(revision 2298)
+++ LMDZ5/branches/testing/libf/phylmd/cosp/congvec.h	(revision 2298)
@@ -0,0 +1,54 @@
+
+! *****************************COPYRIGHT****************************
+! (c) British Crown Copyright 2009, the Met Office.
+! All rights reserved.
+! 
+! Redistribution and use in source and binary forms, with or without 
+! modification, are permitted provided that the
+! following conditions are met:
+! 
+!     * Redistributions of source code must retain the above 
+!       copyright  notice, this list of conditions and the following 
+!       disclaimer.
+!     * Redistributions in binary form must reproduce the above 
+!       copyright notice, this list of conditions and the following 
+!       disclaimer in the documentation and/or other materials 
+!       provided with the distribution.
+!     * Neither the name of the Met Office nor the names of its 
+!       contributors may be used to endorse or promote products
+!       derived from this software without specific prior written 
+!       permission.
+! 
+! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+! OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
+! 
+! *****************************COPYRIGHT*******************************
+! *****************************COPYRIGHT*******************************
+
+      do irand = 1, npoints
+          ! Marsaglia CONG algorithm
+          seed(irand)=69069*seed(irand)+1234567
+          ! mod 32 bit overflow
+          seed(irand)=mod(seed(irand),2**30)   
+          ran(irand)=seed(irand)*0.931322574615479E-09
+      enddo
+
+      ! convert to range 0-1 (32 bit only)
+      overflow_32=i2_16*i2_16
+      if ( overflow_32 .le. huge32 ) then
+          do irand = 1, npoints
+              ran(irand)=ran(irand)+1
+              ran(irand)=(ran(irand))-int(ran(irand))
+          enddo
+      endif
+
+
